<?php

namespace FiloBlu\CheckoutExtend\Api\Plugin\Sales;

use \Magento\Sales\Api\Data\OrderInterface;

class OrderManagementInterface {

    protected $_subscriberFactory;
    protected $_helper;
    protected $_logger;
    protected $_quoteFactory;
    protected $_request;

    public function __construct(
    \Magento\Newsletter\Model\SubscriberFactory $subscriberFactory, \FiloBlu\CheckoutExtend\Helper\Data $helper, \Magento\Quote\Model\QuoteFactory $quoteFactory, \Magento\Framework\App\RequestInterface $request
    ) {
        $this->_subscriberFactory = $subscriberFactory;
        $this->_helper = $helper;
        $this->_quoteFactory = $quoteFactory;
        $this->_request = $request;
    }

    public function afterPlace($interceptor, $order) {

        try {
            if ($this->_helper->getConfigValue("filoblu_checkoutextend_section/newsletter/enabled")) {
                if ($order->getQuoteId()) {
                    $quote = $this->_quoteFactory->create()->load($order->getQuoteId());

                    if ($quote->getIsSubscribeForNewsletter()) {
                        $shippingAddress = $quote->getShippingAddress();

                        if ($quote->getCustomerIsGuest()) {

                            // Set newsletter subscriber data in request
                            $this->_request->setPostValue('firstname', $shippingAddress->getFirstname());
                            $this->_request->setPostValue('lastname', $shippingAddress->getLastname());
                            $this->_request->setPostValue('country_id', $shippingAddress->getCountryId());
                            $this->_request->setPostValue('phone', $shippingAddress->getTelephone());
                            $this->_request->setPostValue('source', "CHECKOUT");
                            $this->_request->setPostValue('language', $this->_helper->getCurrentLocale());
                            $this->_request->setPostValue('website_name', $this->_helper->getCurrentWebsiteName());

                            // Fields not set: dob - gender - collections - birthday

                            $this->_subscriberFactory->create()->subscribe($quote->getCustomerEmail());
                            
                        } else {

                            // Set newsletter subscriber data in request
                            $this->_request->setPostValue('firstname', $quote->getCustomerFirstname());
                            $this->_request->setPostValue('lastname', $quote->getCustomerLastname());
                            $this->_request->setPostValue('country_id', $shippingAddress->getCountryId());
                            $this->_request->setPostValue('phone', $shippingAddress->getTelephone());
                            $this->_request->setPostValue('source', "CHECKOUT");
                            $this->_request->setPostValue('language', $this->_helper->getCurrentLocale());
                            $this->_request->setPostValue('website_name', $this->_helper->getCurrentWebsiteName());

                            // Fields not set: dob - gender - collections - birthday

                            $this->_subscriberFactory->create()->subscribeCustomerById($quote->getCustomerId());
                        }
                    }
                }
            }
        } catch (\Exception $ex) {
            
        }


        return $order;
    }

}
