<?php

namespace FiloBlu\CheckoutExtend\Model\Plugin\Checkout;

use Magento\Quote\Model\QuoteRepository;
use Magento\Checkout\Model\ShippingInformationManagement as ShippingManagement;
use Magento\Checkout\Api\Data\ShippingInformationInterface;

class ShippingInformationManagement {

    protected $_helper;
    protected $_quoteRepository;

    public function __construct(
    QuoteRepository $quoteRepository, \FiloBlu\CheckoutExtend\Helper\Data $helper
    ) {
        $this->_quoteRepository = $quoteRepository;
        $this->_helper = $helper;
    }

    /**
     * @param ShippingManagement $subject
     * @param $cartId
     * @param ShippingInformationInterface $addressInformation
     */
    public function beforeSaveAddressInformation(
    ShippingManagement $subject, $cartId, ShippingInformationInterface $addressInformation
    ) {

        if ($this->_helper->getConfigValue("filoblu_checkoutextend_section/newsletter/enabled")) {
            $shippingAddress = $addressInformation->getShippingAddress();
            $extAttributes = $shippingAddress->getExtensionAttributes();
            if ($extAttributes) {
                $newsletterSubscribe = $extAttributes->getIsSubscribeForNewsletter() ? 1 : 0;
                $quote = $this->_quoteRepository->getActive($cartId);
                $quote->setIsSubscribeForNewsletter($newsletterSubscribe);
            }
        }
    }

}
